__gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >(3cxx)

NAME
__gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc > - Primary template, base class for branch structure policies.

SYNOPSIS

#include <branch_policy.hpp>

Inherited by __gnu_pbds::detail::trie_policy_base< Node_CItr, Node_Itr, _ATraits, _Alloc >, and __gnu_pbds::tree_order_statistics_node_update< Node_CItr, Node_Itr, Cmp_Fn, _Alloc > [private].

  Protected Types

typedef rebind_v::const_pointer const_pointer
typedef rebind_v::const_reference const_reference
typedef Node_Itr::value_type it_type
typedef rebind_k::const_reference key_const_reference
typedef value_type::first_type key_type
typedef remove_const< key_type >::type rckey_type
typedef remove_const< value_type >::type rcvalue_type
typedef _Alloc::template rebind< rckey_type >::other rebind_k
typedef _Alloc::template rebind< rcvalue_type >::other rebind_v
typedef rebind_v::reference reference
typedef std::iterator_traits< it_type >::value_type value_type

  Protected Member Functions

virtual it_type end ()=0
it_type end_iterator () const

  Static Protected Member Functions

static key_const_reference extract_key (const_reference r_val)

Detailed Description

  template<typename Node_CItr, typename Node_Itr, typename _Alloc>
struct __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >"Primary template, base class for branch structure policies.

Definition at line 52 of file branch_policy.hpp.

Member Typedef Documentation

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef rebind_v::const_pointer __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::const_pointer [protected]

Definition at line 67 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef rebind_v::const_reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::const_reference [protected]

Definition at line 66 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef Node_Itr::value_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::it_type [protected]

Definition at line 55 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef rebind_k::const_reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::key_const_reference [protected]

Definition at line 69 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef value_type::first_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::key_type [protected]

Definition at line 57 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef remove_const<key_type>::type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rckey_type [protected]

Definition at line 60 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef remove_const<value_type>::type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rcvalue_type [protected]

Definition at line 59 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef _Alloc::template rebind<rckey_type>::other __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rebind_k [protected]

Definition at line 63 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef _Alloc::template rebind<rcvalue_type>::other __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::rebind_v [protected]

Definition at line 62 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef rebind_v::reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::reference [protected]

Definition at line 65 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > typedef std::iterator_traits<it_type>::value_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::value_type [protected]

Definition at line 56 of file branch_policy.hpp.

Constructor & Destructor Documentation

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > virtual __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::~branch_policy () [inline], [protected], [virtual]

Definition at line 83 of file branch_policy.hpp.

Member Function Documentation

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > it_type __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::end_iterator () const [inline], [protected]

Definition at line 79 of file branch_policy.hpp.

  template<typename Node_CItr , typename Node_Itr , typename _Alloc > static key_const_reference __gnu_pbds::detail::branch_policy< Node_CItr, Node_Itr, _Alloc >::extract_key (const_reference r_val) [inline], [static], [protected]

Definition at line 72 of file branch_policy.hpp.

Author

Generated automatically by Doxygen for libstdc++ from the source code.